|******************************************************************************
|
| project name:    Generic Utilities
| author:          David Randall "Ranman" 
|                  derandall99@gmail.com
|
| compatible with HW1/HW2/HW3 on all AMS versions up to 3.10
|
|******************************************************************************


| C prototype:
|void GrayFillScreen_R(
|   register short color asm("%d0"),
|   register void* lightplane asm("%a0"),
|   register void* darkplane asm("%a1"))
|   __attribute__((__stkparm__));

| This is a modified version of GrayClearScreen2B_R
| Modifications by David Randall

.data
.globl GraySetScreenColor_R
.even

GraySetScreenColor_R:
    move.l   %d0,%d5
    movem.l  %d3-%d7/%a2-%a4,-(%sp)
    lea      (0xf00,%a0),%a0
    lea      (0xf00,%a1),%a1
    andi.l   #0x1,%d0
    cmpi.b   #0x1,%d0
    bne      _GraySetScreenColor_R_label1
    move.q   #-1,%d0
_GraySetScreenColor_R_label1:
    andi.l   #0x2,%d5
    cmpi.b   #0x2,%d5
    bne      _GraySetScreenColor_R_label2
    move.q   #-1,%d5
_GraySetScreenColor_R_label2:
    move.l   %d0,%d1
    move.l   %d0,%d2
    move.l   %d0,%d3
    move.l   %d0,%d4
    move.l   %d5,%d6
    movea.l  %d5,%a2
    movea.l  %d5,%a3
    movea.l  %d5,%a4
    moveq    #23,%d7
_GraySetScreenColor_R_loop1:
    movem.l  %d0-%d4,-(%a0)
    movem.l  %d5-%d6/%a2-%a4,-(%a1)
    movem.l  %d0-%d4,-(%a0)
    movem.l  %d5-%d6/%a2-%a4,-(%a1)
    movem.l  %d0-%d4,-(%a0)
    movem.l  %d5-%d6/%a2-%a4,-(%a1)
    movem.l  %d0-%d4,-(%a0)
    movem.l  %d5-%d6/%a2-%a4,-(%a1)
    movem.l  %d0-%d4,-(%a0)
    movem.l  %d5-%d6/%a2-%a4,-(%a1)
    movem.l  %d0-%d4,-(%a0)
    movem.l  %d5-%d6/%a2-%a4,-(%a1)
    movem.l  %d0-%d4,-(%a0)
    movem.l  %d5-%d6/%a2-%a4,-(%a1)
    movem.l  %d0-%d4,-(%a0)
    movem.l  %d5-%d6/%a2-%a4,-(%a1)
    dbf      %d7,_GraySetScreenColor_R_loop1
    movem.l  (%sp)+,%d3-%d7/%a2-%a4
    rts
