// Header File
// Created 3/5/2005; 11:08:34 AM

//******************************************************************************
//
// file name:       FontUtils.h
//
// author:          David Randall "Ranman" 
//                  derandall99@gmail.com
//
//******************************************************************************


#ifndef _FontUtils
#define _FontUtils

typedef enum
{
	COLOR_White = 0,
	COLOR_LGray,
	COLOR_DGray,
	COLOR_Black,
	COLOR_TotalColors
} FontColorEnum;

typedef struct
{
	char* pFont;
	unsigned short  width;
	unsigned short  height;
} UserFontType;

extern unsigned char font4x6[];
extern unsigned char font4x7[];
extern unsigned char apogee_font8x8[];
extern unsigned char apogee_font8x10[];


void myGraySingleSprite8_COLOR_R(
	register short x asm("%d0"),
	register short y asm("%d1"),
	register short h asm("%d2"),
	unsigned char *sprt,    // a2
	unsigned short color,   // d4
	unsigned short eorMask, // d6
	register void *dest0 asm("%a0"),
	register void *dest1 asm("%a1"))
	 __attribute__((__stkparm__));

extern UserFontType userFont;
void SetUserFont(char* pFont, unsigned char fontWidth, unsigned char fontHeight);
void GrayUserDrawStr(unsigned char x, unsigned char y, const char* str, unsigned short color, unsigned short attribute);


#endif
